/*
 * tokyocabinet.h
 */

/* Prologue */
#ifndef GAUCHE_TOKYOCABINET_H
#define GAUCHE_TOKYOCABINET_H

#include <gauche.h>
#include <gauche/extend.h>

#include <tcutil.h>
#include <tcbdb.h>
#include <tchdb.h>
#include <stdlib.h>
#include <stdbool.h>
#include <stdint.h>




SCM_DECL_BEGIN

/*
 * The following entry is a dummy one.
 * Replace it for your declarations.
 */

/*
(defun insert-class-decl (name)
  (let ((downcase-name (replace-regexp-in-string
			"-" "_"
			(downcase name)))
	(init-upcase-name (mapconcat #'upcase-initials (split-string name "[-_]") ""))
	(upcase-name (replace-regexp-in-string
		      "-" "_"
		      (upcase name))))
    (insert (format "\nSCM_CLASS_DECL(Scm_%sClass);
static void %s_print(ScmObj, ScmPort *, ScmWriteContext*);

#define SCM_CLASS_%s (&Scm_%sClass)
#define SCM_%s(obj)  ((Scm%s*)obj)
#define SCM_%sP(obj) SCM_XTYPEP(obj, SCM_CLASS_%s)

typedef struct Scm%sRec {
    SCM_HEADER;
    ScmObj name;
    // write manually
} Scm%s;
" init-upcase-name downcase-name upcase-name init-upcase-name upcase-name init-upcase-name upcase-name upcase-name init-upcase-name init-upcase-name))))
 */

// (insert-class-decl "raw-tcbdb")
// (insert-class-decl "raw-tchdb")
SCM_CLASS_DECL(Scm_RawTcbdbClass);
SCM_CLASS_DECL(Scm_RawTchdbClass);



static void raw_tcbdb_print(ScmObj, ScmPort *, ScmWriteContext*);
static void raw_tchdb_print(ScmObj, ScmPort *, ScmWriteContext*);



#define SCM_CLASS_RAW_TCBDB (&Scm_RawTcbdbClass)
#define SCM_RAW_TCBDB(obj)  ((ScmRawTcbdb*)obj)
#define SCM_RAW_TCBDB_P(obj) SCM_XTYPEP(obj, SCM_CLASS_RAW_TCBDB)

#define SCM_CLASS_RAW_TCHDB (&Scm_RawTchdbClass)
#define SCM_RAW_TCHDB(obj)  ((ScmRawTchdb*)obj)
#define SCM_RAW_TCHDB_P(obj) SCM_XTYPEP(obj, SCM_CLASS_RAW_TCHDB)



typedef struct ScmRawTcbdbRec {
    SCM_HEADER;
    TCBDB* bdb;
    // write manually
} ScmRawTcbdb;

typedef struct ScmRawTchdbRec {
    SCM_HEADER;
    TCHDB* hdb;
    // write manually
} ScmRawTchdb;



// (insert-class-decl "tcbdbcur")
SCM_CLASS_DECL(Scm_TcbdbcurClass);
static void tcbdbcur_print(ScmObj, ScmPort *, ScmWriteContext*);

#define SCM_CLASS_TCBDBCUR (&Scm_TcbdbcurClass)
#define SCM_TCBDBCUR(obj)  ((ScmTcbdbcur*)obj)
#define SCM_TCBDBCURP(obj) SCM_XTYPEP(obj, SCM_CLASS_TCBDBCUR)

typedef struct ScmTcbdbcurRec {
    SCM_HEADER;
    // write manually
    BDBCUR* cur;
} ScmTcbdbcur;



static void tcbdb_finalize(ScmObj obj, void *data);
static void tcbdb_print(ScmObj obj, ScmPort *out, ScmWriteContext *ctx);

static void tchdb_finalize(ScmObj obj, void *data);
static void tchdb_print(ScmObj obj, ScmPort *out, ScmWriteContext *ctx);



extern ScmObj Scm_tcbdb_ecode(ScmRawTcbdb* bdb);
extern ScmObj Scm_tcbdb_new(void);
extern ScmObj Scm_tcbdb_open(ScmRawTcbdb* bdb, ScmString* path, int omode);
extern ScmObj Scm_tcbdb_close(ScmRawTcbdb* bdb);
extern ScmObj Scm_tcbdb_out2(ScmRawTcbdb* bdb, ScmString* key);

extern ScmObj Scm_tchdb_ecode(ScmRawTchdb* bdb);
extern ScmObj Scm_tchdb_new(void);
extern ScmObj Scm_tchdb_open(ScmRawTchdb* bdb, ScmString* path, int omode);
extern ScmObj Scm_tchdb_close(ScmRawTchdb* bdb);
extern ScmObj Scm_tchdb_put2(ScmRawTchdb* bdb, ScmString* key, ScmString* val);
extern ScmObj Scm_tchdb_get2(ScmRawTchdb* bdb, ScmString* key);
extern ScmObj Scm_tchdb_out2(ScmRawTchdb* bdb, ScmString* key);
extern ScmObj Scm_tchdbcur_new(ScmRawTchdb* bdb);



/* B+ tree specific API */
extern ScmObj Scm_tcbdbcur_new(ScmRawTcbdb* bdb);
extern ScmObj Scm_tcbdbcur_del(ScmTcbdbcur* cur);
extern ScmObj Scm_tcbdbcur_first(ScmTcbdbcur* cur);
extern ScmObj Scm_tcbdbcur_last(ScmTcbdbcur* cur);
extern ScmObj Scm_tcbdbcur_prev(ScmTcbdbcur* cur);
extern ScmObj Scm_tcbdbcur_next(ScmTcbdbcur* cur);
extern ScmObj Scm_tcbdbcur_key2(ScmTcbdbcur* cur);
extern ScmObj Scm_tcbdbcur_val2(ScmTcbdbcur* cur);


/* Hash specific API */
extern ScmObj Scm_tchdb_iterinit(ScmRawTchdb* hdb);
extern ScmObj Scm_tchdb_iternext2(ScmRawTchdb* hdb);
extern ScmObj Scm_tchdb_iternext3(ScmRawTchdb* hdb);


/* Epilogue */
SCM_DECL_END

#endif  /* GAUCHE_TOKYOCABINET_H */
